//variable for active button
var ActiveButton = $("div.notabene-active-button");

Drupal.behaviors.notabeneBehaviour = function (context) {
	//click processor
	$(document).click( function(e) {
                //check clicked object
                if ($(e.target).parents("div.notabene-note-hover-container").length) return; //no popups for hover container
		var clickedObject = $(e.target).parents("div.notabene-note-icon"); 
		if (clickedObject.length) {
			ActiveButton = $(clickedObject).parents("div.notabene-exported-button");
	      Drupal.modalFrame.open({url: $(clickedObject).find("a.notabene-note-link").attr('href'), 
		                          width: 200, 
		                          height: 400,
		                          onLoad: processModalFrameContent });
	      return false;
	    }
	});
	//bind hover events
	$("div.notabene-exported-button").find("div.notabene-note-icon").bindHover();
}

jQuery.fn.bindHover = function () {
	$(this).hover(
	  function () {
        var Link = $(this).find("a.notabene-note-link");
	    //hover effect
	    Link.next("div.notabene-note-hover-container")
	             .load(Link.attr('href')+"/hover")
	             .css({"position": "absolute", "right": "50%", "bottom": "90%"});
	    Link.next("div.notabene-note-hover-container").show();
	  },
	  function (e) {
	    //unhover effect
        $(this).find("a.notabene-note-link").next("div.notabene-note-hover-container").empty().hide();
	  }
	);
}

processModalFrameContent = function (modalFrame, $iFrameWindow, $iFrameDocument) {
  //reload ActiveButton
  ActiveButton.load(ActiveButton.attr('href')); //update notabene button on every iframe reload
  ActiveButton.bindHover();
  //add jQuery counter to show chars remain for note textarea
  var lengthMsg = $iFrameDocument.find("div.notabene-length-limit-msg");
  //we process length only if we have actual limit and there is lengthMsg
  if (lengthMsg.length > 0) {
	  var lengthVal = lengthMsg.find("span.notabene-note-char-length").text();
	  lengthVal = (lengthVal - 0); //toInt
	  //setup new message
	  lengthMsg.html(Drupal.t('There are <span class="notabene-note-char-length">@count</span> characters left',
	                          {'@count': lengthVal}));
	  var noteTextarea = $iFrameDocument.find("textarea");
	  //keypress event
	  noteTextarea.keyup( function() {
	    var newValue = $(this).val();
	    if (newValue.length <= lengthVal) {
	      //change is ok, update text
          lengthMsg.html(Drupal.t('There are <span class="notabene-note-char-length">@count</span> characters left',
                                  {'@count': (lengthVal-newValue.length)}));
          //normal font
          lengthMsg.find("span.notabene-note-char-length").css("font-weight","normal");
	    } else {
	      //crop string since we've reached our limit
	      $(this).val($(this).val().substr(0,lengthVal));
	      lengthMsg.find("span.notabene-note-char-length").css("font-weight","bold");
	    }
	  });
  }
  //process icons to emulate buttons
  var icons = $iFrameDocument.find("div.notabene-edit-icons");
  icons.find("div.notabene-edit-note-icon").each( function () {
      $(this).mousedown( function (e) {
        $(this).buttonMouseDown();
      });
      $(this).mouseup( function (e) {
        $(this).buttonMouseUp();
      });
      //edit note
      $(this).click( function(e) {
        var Note = $(this).parents("div.notabene-note"); 
        //get note id
        var note_id = Note.attr("id").slice(4);
        //set text as note's html with stripped tags
        $iFrameDocument.find("textarea").val(Note.find("span.notabene-note-text").html().replace(/<\/?[^>]+>/gi, ''));
        //set hidden
        $iFrameDocument.find("input[@name='edit_id']").val(note_id);
        //setup checkboxes
        $iFrameDocument.find("input[@name='note_type[1]']").removeAttr('checked');
        $iFrameDocument.find("input[@name='note_type[2]']").removeAttr('checked');
        Note.find("div.notabene-note-type-icon").each(function () {
          //if important note, check important box
          if ($(this).find("img").attr("name") == "important-note") {
            $iFrameDocument.find("input[@name='note_type[1]']").attr('checked', 'checked');
          }
          //if private note, check important box
          if ($(this).find("img").attr("name") == "private-note") {
              $iFrameDocument.find("input[@name='note_type[2]']").attr('checked', 'checked');
          }
        });
      });
    }
  );
  icons.find("div.notabene-delete-note-icon").each( function () {
      $(this).mousedown( function (e) {
        $(this).buttonMouseDown();
      });
      $(this).mouseup( function (e) {
        $(this).buttonMouseUp();
      });
      //delete button clicked
      $(this).click( function () {
        //get Note and note_id
        var Note = $(this).parents("div.notabene-note");
        var note_id = Note.attr("id").slice(4);
        //get delete form and show it
        $.post(Drupal.settings.basePath + "notes/delete_note/" + note_id,function (data) {
          Note.after(data);
          Note.hide();
          //get form and adjust it for ajax
          var DelForm = Note.parent().find("div.notabene-delete-note-form").find("form");
          DelForm.ajaxForm({
            success: function (responseText,statusText) {
              //hide form
              var FormParent = $(this.$form).parent();
              FormParent.hide();
              //delete form
              FormParent.find("div.notabene-delete-note-form").remove();
              //remote deleted note
              Note.remove();
              //reload ActiveButton
              ActiveButton.load(ActiveButton.attr('href')); //update notabene button on every note removal
              ActiveButton.bindHover();
            },
            beforeSubmit: function (data, $form, opts) {
              //save form
              this.$form = $form;
            }
          });
        //cancel button
        DelForm.find("input.cancel_delete_button").click(function () {
          //hide form
          var NoteForm = $(this).parent().parent().parent();
          NoteForm.hide();
          //delete form
          NoteForm.find("div.notabene-delete-note-form").remove();
          Note.show();
          return false;
        });
        //submit form
        DelForm.submit (function () {
          return false;
        });
     }); 
    });
    }
  );
}

//icon is clicked
jQuery.fn.buttonMouseDown = function () {
  $(this).find("img").height($(this).find("img").height()-2);
  $(this).find("img").width($(this).find("img").width()-2);
}

jQuery.fn.buttonMouseUp = function () {
  $(this).find("img").height($(this).find("img").height()+2);
  $(this).find("img").width($(this).find("img").width()+2);
}
